#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <syslog.h>
#include <unistd.h>

#include "tree.h"
#include "set.h"
#include "menu.h"
#include "config.h"
#include "misc.h"
#include "exec.h"
#include "rules.h"

char rulesfile[256];
FILE *rulesfp;
extern char *progname;
extern struct dict *SetVariables;
extern struct dict *Menus;
extern char *basedirectory;
extern char **environ;

void pressanykey(void);
int pressyn(void);

void set_rules_file(char *fn)
{
  rulesfp=fopen(fn,"r");
  if(rulesfp==NULL)
    {
      fprintf(stderr,"%s: Could not open %s\n",progname,fn);
      perror(progname);	
      exit(EXIT_FAILURE);
     }
   else
     {
       strncpy(rulesfile,fn,strlen(fn));
       fclose(rulesfp);
     }
}

int agree_rules(void)
{
char **pagerv = NULL;
int pagerc = 0;
register uid_t uid;
char agreefile[256]; /* me malloc and strcat just dont get on.....*/
register struct passwd *pw;
FILE *agreerulesfp;
char *user = NULL;

  uid=getuid ();
  pw = getpwuid (uid);
  if (pw!=NULL && pw->pw_dir!=NULL)
    {
      strncpy(agreefile,(pw->pw_dir),strlen(pw->pw_dir));
      strcat(agreefile,AGREEFILE);
    }
  else
    {
      fprintf(stdout,"Um... you dont appear to have a home directory!\n");
      exit(EXIT_FAILURE);
    }

  agreerulesfp=fopen(agreefile,"r");
  if(agreerulesfp!=NULL)
    {
      fclose(agreerulesfp);
      return(0);
    }
  else
  {
    display_file(rulesfile);
    if(pressyn()!=0)
      {
        fprintf(stdout,"\n [--I'm afraid we cant let you in then!--] \n");
        sleep(1);
        return(1);
      }
    else
      {
	creat(agreefile,400);
        if (find_variable("logging",NULL) == 1)
	  {
            find_variable ("user",&user);  
            syslog (LOG_LOCAL1 | LOG_INFO, 
		"%d: %s UID (%d) Agreed to flash rules.", 
		getpid (), user, getuid ());
	  }
        return(0);
      }
  }
}
